/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.wahlvorschlag.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="WAHLVORSCHLAGSDOKUMENT.Wahlvorschlag",
     query="select o from Wahlvorschlagsdokument o where o.wahlvorschlag = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "WAHLVORSCHLAGSDOKUMENT")
// @javax.persistence.IdClass(WahlvorschlagsdokumentPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Wahlvorschlagsdokument
extends AbstractWahlvorschlagsdokument
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Wahlvorschlagsdokument() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Wahlvorschlagsdokument(Wahlvorschlagsdokument original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "wahlvorschlagsdokument_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Wahlvorschlagsdokument")
    @javax.persistence.TableGenerator(name = "Wahlvorschlagsdokument", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Wahlvorschlagsdokument", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient WahlvorschlagsdokumentPK pkCache;

  @Override
  public WahlvorschlagsdokumentPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new WahlvorschlagsdokumentPK(getId());
    }

    return pkCache;
  }

  public static <E extends Wahlvorschlagsdokument> java.util.Map<WahlvorschlagsdokumentPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<WahlvorschlagsdokumentPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Wahlvorschlagsdokument> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedAnzahl = false;
          hasChangedWahlvorschlagsdokumentArt = false;
  
      hasChangedWahlvorschlag = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "ANZAHL", nullable = WahlvorschlagsdokumentConstants.ANZAHL_NULLABLE, precision=WahlvorschlagsdokumentConstants.ANZAHL_PRECISION, scale=WahlvorschlagsdokumentConstants.ANZAHL_SCALE)
            
  protected java.lang.Long anzahl =  Long.valueOf("0");

  @javax.persistence.Transient
  protected boolean hasChangedAnzahl = false;

  public boolean hasChangedAnzahl(){
    return hasChangedAnzahl;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertAnzahl = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenAnzahl;
  
  /**
   * 
   *
   * getter for WAHLVORSCHLAGSDOKUMENT.ANZAHL
   */
    @Override   public  java.lang.Long getAnzahl() {
        return anzahl;
      }

  /**
   * 
   *
   * setter for WAHLVORSCHLAGSDOKUMENT.ANZAHL
   *
   * @param anzahl
   */
  @Override   public void setAnzahl( java.lang.Long anzahl) {

       resetTkCache();
                  java.lang.Long anzahlInternal = anzahl;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.anzahl
      , anzahlInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAnzahl |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("anzahl");
      }


             if (!isSeitLadenVeraendertAnzahl) {
          isSeitLadenVeraendertAnzahl = thisAttributChanged;
         if (isSeitLadenVeraendertAnzahl){
           wertNachLadenAnzahl=this.anzahl;
         }
       }
      

       this.anzahl = anzahlInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "WAHLVORSCHLAGSDOKUMENT_ART", nullable = WahlvorschlagsdokumentConstants.WAHLVORSCHLAGSDOKUMENT_ART_NULLABLE)
    
  protected de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentArt wahlvorschlagsdokumentArt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWahlvorschlagsdokumentArt = false;

  public boolean hasChangedWahlvorschlagsdokumentArt(){
    return hasChangedWahlvorschlagsdokumentArt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWahlvorschlagsdokumentArt = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentArt wertNachLadenWahlvorschlagsdokumentArt;
  
  /**
   * 
   *
   * getter for WAHLVORSCHLAGSDOKUMENT.WAHLVORSCHLAGSDOKUMENT_ART
   */
    @Override   public  de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentArt getWahlvorschlagsdokumentArt() {
        return wahlvorschlagsdokumentArt;
      }

  /**
   * 
   *
   * setter for WAHLVORSCHLAGSDOKUMENT.WAHLVORSCHLAGSDOKUMENT_ART
   *
   * @param wahlvorschlagsdokumentArt
   */
  @Override   public void setWahlvorschlagsdokumentArt( de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentArt wahlvorschlagsdokumentArt) {

       resetTkCache();
                  de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentArt wahlvorschlagsdokumentArtInternal = wahlvorschlagsdokumentArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahlvorschlagsdokumentArt
      , wahlvorschlagsdokumentArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWahlvorschlagsdokumentArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wahlvorschlagsdokumentArt");
      }


             if (!isSeitLadenVeraendertWahlvorschlagsdokumentArt) {
          isSeitLadenVeraendertWahlvorschlagsdokumentArt = thisAttributChanged;
         if (isSeitLadenVeraendertWahlvorschlagsdokumentArt){
           wertNachLadenWahlvorschlagsdokumentArt=this.wahlvorschlagsdokumentArt;
         }
       }
      

       this.wahlvorschlagsdokumentArt = wahlvorschlagsdokumentArtInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Wahlvorschlag
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLVORSCHLAG_ID", referencedColumnName="WAHLVORSCHLAG_ID"))
  protected de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag;

  /**
   * 
   */
  @Override
  public void setWahlvorschlag( de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahlvorschlag
    , wahlvorschlag);

    attributeChanged |= thisAttributChanged;

    hasChangedWahlvorschlag |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahlvorschlag");
    }

    this.wahlvorschlag = wahlvorschlag;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag getWahlvorschlag(){
    return this.wahlvorschlag;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahlvorschlag = false;

  public boolean hasChangedWahlvorschlag(){
    return hasChangedWahlvorschlag;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Wahlvorschlagsdokument:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Wahlvorschlagsdokument other){
                             other.anzahl = this.anzahl;
                                other.wahlvorschlagsdokumentArt = this.wahlvorschlagsdokumentArt;
           
  other.setWahlvorschlag(this.getWahlvorschlag());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Wahlvorschlagsdokument.class)){
        copyEntityAttributesUsingSetter((Wahlvorschlagsdokument) other.castTo(Wahlvorschlagsdokument.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Wahlvorschlagsdokument: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Wahlvorschlagsdokument other){
               other.setAnzahl(this.anzahl);
                  other.setWahlvorschlagsdokumentArt(this.wahlvorschlagsdokumentArt);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Wahlvorschlagsdokument other){
                       if (hasChangedAnzahl) {
        other.setAnzahl(this.anzahl);
      }
                             if (hasChangedWahlvorschlagsdokumentArt) {
        other.setWahlvorschlagsdokumentArt(this.wahlvorschlagsdokumentArt);
      }
             }





    @javax.persistence.Transient
    private transient WahlvorschlagsdokumentTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public WahlvorschlagsdokumentTK getWahlvorschlagsdokumentTK(){
    if (tkCache==null) {
    tkCache = new WahlvorschlagsdokumentTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getWahlvorschlagsdokumentTK();
    }

  @Override
  public WahlvorschlagsdokumentUK getUk(){
    return getWahlvorschlagsdokumentUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Wahlvorschlagsdokument.class;
  }

public WahlvorschlagsdokumentUK getWahlvorschlagsdokumentUK(){

   return  new WahlvorschlagsdokumentUK(



  );
}

  @javax.persistence.Transient
  private transient WahlvorschlagsdokumentProperties properties;

  public WahlvorschlagsdokumentProperties getProperties(){
    if (properties == null) {
      properties = new WahlvorschlagsdokumentProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public WahlvorschlagsdokumentProperties getWahlvorschlagsdokumentProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return WahlvorschlagsdokumentConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(WahlvorschlagsdokumentConstants.MESSAGE_KEY_ANZAHL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlvorschlagsdokumentConstants.MESSAGE_KEY_ANZAHL_EINZAHL);

        anzahl =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(WahlvorschlagsdokumentConstants.MESSAGE_KEY_WAHLVORSCHLAGSDOKUMENT_ART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlvorschlagsdokumentConstants.MESSAGE_KEY_WAHLVORSCHLAGSDOKUMENT_ART_EINZAHL);

        wahlvorschlagsdokumentArt =
     (de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentArt) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertAnzahl) {
      result.put(WahlvorschlagsdokumentConstants.MESSAGE_KEY_ANZAHL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenAnzahl , anzahl));
    }
                            if (isSeitLadenVeraendertWahlvorschlagsdokumentArt) {
      result.put(WahlvorschlagsdokumentConstants.MESSAGE_KEY_WAHLVORSCHLAGSDOKUMENT_ART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenWahlvorschlagsdokumentArt , wahlvorschlagsdokumentArt));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertAnzahl = false;
      wertNachLadenAnzahl = null;
                          isSeitLadenVeraendertWahlvorschlagsdokumentArt = false;
      wertNachLadenWahlvorschlagsdokumentArt = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "WAHLVORSCHLAGSDOKUMENT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Wahlvorschlagsdokument";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(anzahl, this, WahlvorschlagsdokumentConstants.MESSAGE_KEY_ANZAHL_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(WahlvorschlagsdokumentConstants.ANZAHL_MAX_VALUE, WahlvorschlagsdokumentConstants.ANZAHL_MIN_VALUE, anzahl, this, WahlvorschlagsdokumentConstants.MESSAGE_KEY_ANZAHL_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(wahlvorschlagsdokumentArt, this, WahlvorschlagsdokumentConstants.MESSAGE_KEY_WAHLVORSCHLAGSDOKUMENT_ART_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
